<?php
//2016-11-08 fixed issues for translated installs over day names breaking email and sms.


/**
 *
 * displays rota for $service_id
 * 
 * @author  Andy Moyle
 * @param    $service_id
 * @return   html string
 * @version  0.1
 *
 * refactored 11th April 2016 to remove multi-service bug
 *  29th Sept 2016 made $days not translated to remove strtotime not working for non English installs
 * 
 */

function church_admin_rota_list($service_id=NULL)
{
	//initialise
	global $wpdb;
	$days=array(1=>__('Sunday','church-admin'),2=>__('Monday','church-admin'),3=>__('Tuesday','church-admin'),4=>__('Wednesday','church-admin'),5=>__('Thursday','church-admin'),6=>__('Friday','church-admin'),7=>__('Saturday','church-admin'));
	
	$wpdb->show_errors();
	//check for service_id
	$services=$wpdb->get_results('SELECT * FROM '.CA_SER_TBL);
	$noOfServices=$wpdb->num_rows;
	if($noOfServices==0)//no services, create one
	{
		//no services stored so create one
		$wpdb->query('INSERT INTO '.CA_SER_TBL.' (service_name,service_day,service_time,venue,address,lat,lng,first_meeting) VALUES ("'.__('Default Sunday Service','church-admin').'","1","10:00","'.__('Main Venue','church-admin').'","'.esc_sql(serialize(array('address_line1'=>"",'address_line2'=>"",'town'=>"",'county'=>"",'postcode'=>""))).'","52.0","0.0","'.date('Y-m-d').'")');
		$service_id=$wpdb->insert_id;
	}
	elseif($noOfServices==1)
	{
		//only one service so use it
		if(empty($service_id))$service_id=$wpdb->get_var('SELECT service_id FROM '.CA_SER_TBL );
	}
	else
	{
		//always show choose service form if more than one
		echo'<form action="admin.php?page=church_admin/index.php&tab=rota&amp;action=church_admin_rota_list" method="POST">';
		echo'<table class="form-table"><tbody><tr><th scope=row>'.__('Change Service?','church-admin').'</th><td><select name="service_id">';
		echo'<option>'.__('Choose Service','church-admin').'</option>';
		foreach($services AS $service)
		{
			echo'<option value="'.intval($service->service_id).'">'.esc_html($service->service_name.' on '.$days[$service->service_day].' at '.$service->service_time.' '.$service->venue).'</option>';
		}
		echo'</select> <input type="submit" name="choose_service" value="'.__('Choose service','church-admin').' &raquo;" /></td></tr></tbody></table></form>';
	}
	$service=$wpdb->get_row('SELECT a.*,b.venue FROM '.CA_SER_TBL.' a, '.CA_SIT_TBL.' b WHERE a.site_id=b.site_id AND a.service_id="'.esc_sql($service_id).'"');
	
	if(!empty($service))echo'<h2>'.sprintf(__('Rota  for %1$s on %2$s at %3$s at %4$s','church-admin'),$service->service_name,$days[$service->service_day],$service->venue,$service->service_time).'</h2>';
	
	//show list once service_id has been specified		
	if(!empty($service_id))
	{//service_id specified
			
		$allRotaJobs=$wpdb->get_results('SELECT * FROM '.CA_RST_TBL.'  ORDER by rota_order');
		//extract ids and name of rota job for current service
		$rotaJobs=array();
		if(!empty($allRotaJobs))
		{
			
			foreach($allRotaJobs AS $eachRotaJob)
			{
				$service_ids=maybe_unserialize($eachRotaJob->service_id);
				
				if(is_array($service_ids)&&in_array($service_id,$service_ids)){$rotaJobs[$eachRotaJob->rota_id]=$eachRotaJob->rota_task;}
			}
			//we now have an array $rotaJobs that contains id as key and name of job as value
			
		}
		if(!empty($rotaJobs))
		{//some jobs already so proceed
			
			
			//begin to create the table
			//build rota tableheader
			echo'<p>'.__('Click a table cell to edit it','church-admin').'</p>';
			
			$thead='<tr><th>'.__('Edit','church-admin').'</th><th>'.__('Delete','church-admin').'</th><th width="100">'.__('Date','church-admin').'</th>';
			foreach($rotaJobs AS $id=>$value)$thead.='<th>'.esc_html($value).'</th>';
			$thead.='<th>'.__('Copy from date','church-admin').'</th></tr>';
			//output table header
			echo '<table class="widefat striped"><thead>'.$thead.'</thead><tfoot>'.$thead.'</tfoot><tbody>';
			
			//grab dates of services...
			$sql='SELECT * FROM '.CA_ROT_TBL.' WHERE rota_date>="'.date('Y-m-d').'" AND service_id="'.esc_sql($service_id).'" ORDER BY rota_date ';
			$dateResults=$wpdb->get_results($sql);
			if(empty($dateResults))
			{//if empty rota, create 3 months worth of dates
				church_admin_rota_add_three_months($service_id);
				$dateResults=$wpdb->get_results($sql);
			}
			$date_options='';
			foreach($dateResults AS $dateRow)
			{
				//form data for copy cell
				$date_options.='<option value="'.intval($dateRow->rota_id).'">'.mysql2date(get_option('date_format'),$dateRow->rota_date).'</option>';
				//links
				$edit_url='admin.php?page=church_admin/index.php&tab=rota&action=church_admin_edit_rota&id='.intval($dateRow->rota_id).'&amp;service_id='.intval($service_id);
				$delete_url='admin.php?page=church_admin/index.php&tab=rota&action=church_admin_delete_rota&id='.intval($dateRow->rota_id);
				//current rota'd people
				$currentData=maybe_unserialize($dateRow->rota_jobs);
				if(empty($currentData))
				{
					//if no people stored for any jobs yet, form an empty array using keys from $rotaJobs
					$currentData=array();
					foreach($rotaJobs AS $key=>$value)$currentData[$key]=__('Click to edit','church-admin');
				}
				//start row
				echo '<tr><td><a href="'.wp_nonce_url($edit_url, 'edit_rota').'">'.__('Edit','church-admin').'</a></td>';
				echo'<td><a onclick="return confirm(\''.__('Are you sure?','church-admin').'\');" href="'.wp_nonce_url($delete_url, 'delete_rota').'">'.__('Delete','church-admin').'</a></td>';
				echo'<td>'.mysql2date('jS M Y',$dateRow->rota_date).'</td>';
				foreach($rotaJobs AS $id=>$value)
				{
					$people='';
					$people=church_admin_get_people($currentData[$id]);
					
					echo'<td class="edit" id="'.esc_html($value).'~'.intval($dateRow->rota_id).'">'.esc_html($people).'</td>';
				}
				//copy section
				echo'<td><form action="'.admin_url().'admin.php" method="GET">';
				echo'<input type="hidden" name="page" value="church_admin/index.php"/><input type="hidden" name="tab" value="rota"/><input type="hidden" name="action" value="copy_rota_data"/>';
				echo wp_nonce_field('copy_rota','copy_rota');
				echo'<input type="hidden" name="rota_id" value="'.intval($dateRow->rota_id).'"/><select name="copy_id">';
				echo $date_options.'</select>';
				echo'<input type="submit" value="'.__('Copy rota','church-admin').'"/></form></td>';
				
			}	
			echo'</tbody></table>';
			echo'<script type="text/javascript">jQuery(document).ready(function($) {$(".edit").editable(ajaxurl,{submitdata: {action: "ajax_rota_edit",security:"'.wp_create_nonce('ajax_rota_edit').'"},onblur : "submit"}); });</script>';
			
		}//end of some jobs already so proceed
		else
		{//no jobs for service, so ask for them to be created!
			echo '<p><a  style="color:red" href="'.wp_nonce_url("admin.php?page=church_admin/index.php&tab=rota&amp;action=church_admin_rota_settings_list",'rota_settings_list').'" >'.__('You need to add some rota jobs first','church-admin').' &raquo;<a/></p>';
		}
		
		
	
	}//end of service_id specified
	else
	{//no service_id specified and more than one service
	
		echo'<p>'.__('Please choose a service','church-admin').'</p>';
	}

}







        /**
 *
 * copies data from copy_id to rota_id
 * 
 * @author  Andy Moyle
 * @param    $copy_id,$rota_id
 * @return   html string
 * @version  0.1
 * 
 */
function church_admin_copy_rota($copy_id,$rota_id)
{

	global $wpdb;
	$rota_jobs=$wpdb->get_var('SELECT rota_jobs FROM '.CA_ROT_TBL.' WHERE rota_id="'.esc_sql(intval($copy_id)).'"');
	if(!empty($rota_jobs))
	{
		$wpdb->query('UPDATE '.CA_ROT_TBL.' SET rota_jobs="'.esc_sql($rota_jobs).'" WHERE rota_id="'.esc_sql(intval($rota_id)).'"');
		echo'<div class="updated fade".<p><strong>People copied over</strong></p></div>';
		$service_id=$wpdb->get_var('SELECT service_id FROM '.CA_ROT_TBL.' WHERE rota_id="'.esc_sql(intval($rota_id)).'"');
		church_admin_rota_list($service_id);
	}
}


function church_admin_email_rota($service_id=1,$date=NULL)
{
        /**
 *
 * Emails out the rota 
 * 
 * @author  Andy Moyle
 * @param    $service_id,$date
 * @return   html string
 * @version  0.2
 * 
 * Fix for translated installs, don't translate date
 */  
 	$debug=TRUE;
 	 if($debug)church_admin_debug("********************************************\r\n rota.php line225\r\n".date('Y-m-d')."\r\n********************************************\r\n");
	global $church_admin_version,$wpdb;
	//don't translate days as strtotime doesn't work
	$days=array(1=>'Sunday',2=>'Monday',3=>'Tuesday',4=>'Wednesday',5=>'Thursday',6=>'Friday',7=>'Saturday');
	//grab service details
	$sql='SELECT * FROM '.CA_SER_TBL.' WHERE service_id="'.esc_sql($service_id).'"';
	$service=$wpdb->get_row($sql);
    
	
	
	if(!empty($_POST['rota_email']))
	{//process form and send email
     	if($debug)church_admin_debug("**********\r\n rota.php line206\r\nForm posted\r\n");

		if(empty($date))$date=date('Y-m-d',strtotime($days[$service->service_day]));
		if($debug)church_admin_debug("**********\r\n rota.php line209\r\n date variable \r\n".$date."\r\n");

		$allRotaJobs=$wpdb->get_results('SELECT * FROM '.CA_RST_TBL.' ORDER by rota_order');
		//extract ids and name of rota job for current service
		$rotaJobs=array();
		if(!empty($allRotaJobs))
		{
			
			foreach($allRotaJobs AS $eachRotaJob)
			{
				$service_ids=maybe_unserialize($eachRotaJob->service_id);
				
				if(is_array($service_ids)&&in_array($service_id,$service_ids)){$rotaJobs[$eachRotaJob->rota_id]=$eachRotaJob->rota_task;}
			}
			//we now have an array $rotaJobs that contains id as key and name of job as value in the correct order
		}
		if($debug)church_admin_debug("**********\r\n rota.php line225\r\n Rota Jobs \r\n".print_r($rotaJobs,true)."\r\n");
	
		$dateRow=$wpdb->get_row('SELECT * FROM '.CA_ROT_TBL.' WHERE service_id="'.esc_sql($service_id).'" AND rota_date="'.esc_sql($date).'"');
		if(!empty($dateRow))
		{
			$currentData=maybe_unserialize($dateRow->rota_jobs);
			
			//build rota with jobs
			$user_message=stripslashes(nl2br($_POST['message']));
			//fix floated images for email
			$user_message=str_replace('class="alignleft ','style="float:left;margin-right:20px;" class="',$user_message);
			$user_message=str_replace('class="alignright ','style="float:right;margin-left:20px;" class="',$user_message);
			//$textversion=strip_tags($user_message).'\r\n for '.$service->service_name.' on '.$days[$service->service_day].' at '.$service->service_time.' '.$service->venue.'\r\n';
			$message=$user_message.'<p>'.__('Rota','church-admin').' for  '.$service->service_name.' on '.mysql2date(get_option('date_format'),$date).' at '.$service->service_time.' '.$service->venue.'</p>';
			
			$message.='<table><thead><tr><th>'.__('Job','church-admin').'</th><th>'.__('Who','church-admin').'</th></tr></thead><tbody>';
			foreach($rotaJobs AS $id=>$jobName)
				{
					$people='';
					$people=esc_html(church_admin_get_people($currentData[$id]));
					
					$message.='<tr><td>'.esc_html($jobName).'</td><td>'.$people.'</td></tr>';
				}
				$message.='</table>';
				if($debug)church_admin_debug("**********\r\n rota.php line249\r\n date variable \r\n".$message."\r\n");
			//grab unique people_ids to get email addresses 
			$people_ids=array();
	
			foreach($currentData AS $key=>$value)
			{
				if(!empty($value))
				{
					$jobs=maybe_unserialize($value);
					foreach($jobs AS $k=>$id)
					{
						if(!in_array($id,$people_ids))$people_ids[]=$id;//only add unique ids
					}
				}
			}
			if($debug)church_admin_debug("**********\r\n rota.php line268\r\n People ids \r\n".print_r($people_ids,TRUE)."\r\n");
			//start emailing the message
			$message.='';
			echo'<h2>'.__('Building rota email message for service','church-admin').'</h2>';
			
			echo'<h3>'.__('Building recipient list and sending','church-admin').'</h3>';
			if(!empty($people_ids))
			{
				
				foreach($people_ids AS $key=>$people_id)
				{
					if(!ctype_digit($people_id))
					{
						if($debug)church_admin_debug("**********\r\n rota.php line280\r\n Recipient not stored as people_id\r\n".$people_id."\r\n");
						$people_id=church_admin_get_one_id($people_id);
						if($debug)church_admin_debug("**********\r\n rota.php line283\r\n Recipient converted to  people_id hopefully!\r\n".$people_id."\r\n");
						if(!ctype_digit($people_id)) echo '<p>'.esc_html($people_id).__('is not stored in the directory','church-admin').'</p>';
					}
					$row=$wpdb->get_row('SELECT CONCAT_WS(" ", first_name,last_name) AS name, email FROM '.CA_PEO_TBL.' WHERE people_id="'.esc_sql($people_id).'"');
					if($debug)church_admin_debug("**********\r\n rota.php line280\r\n Recipients \r\n".print_r($row,TRUE)."\r\n");
					if(!empty($row->email))
					{
		    		    if(!empty($row->name))$email_content='<p>'.__('Dear','church-admin').' '.$row->name.',</p>'.$message;
						$whenToSend=get_option('church_admin_cron');
						if($whenToSend=='immediate')
						{
							if($debug)church_admin_debug("**********\r\n rota.php line287\r\n Immediate send\r\n");
							add_filter( 'wp_mail_content_type', 'set_html_content_type' );
							$headers = 'From: '.get_option('blogname').' <'.get_option('admin_email').'>' . "\r\n";
							
							if(wp_mail($row->email,__("This week's service rota",'church-admin'),$email_content,$headers))
							{
								$out='<p>Email to '.esc_html($row->name).' sent immediately</p>';
								echo $out;
								if($debug)church_admin_debug("**********\r\n rota.php line288\r\n ECHO \r\n".$out."\r\n");
							}
							else
							{//log errors								
								global $phpmailer;
								if (isset($phpmailer)) {
									church_admin_debug("**********\r\n rota.php line303\r\n ".print_r($phpmailer->ErrorInfo,TRUE)."\r\n");
								}
							}
							remove_filter( 'wp_mail_content_type', 'set_html_content_type' );
						}
						else
						{			      
							if(QueueEmail($row->email,__("This week's service rota",'church-admin'),$email_content,'',get_option('blogname'),get_option('admin_email'),'',''))
							{
								$out='<p>Email to '.esc_html($row->name).' queued</p>';
								echo $out;
								if($debug)church_admin_debug("**********\r\n rota.php line297\r\n date variable \r\n".$out."\r\n");
							}
						}
					}
				}	
			}
		}
		
		
		
	}//end send out email
	else
	{
		
		if($debug)church_admin_debug("**********\r\n rota.php line315\r\n FORM \r\n");
		echo'<h2>Email service rota  for  '.esc_html($service->service_name.' on '.$days[$service->service_day].' at '.$service->service_time.' '.$service->venue).'</h2><form action="" method="post">';
		echo'<p>'.__('The email will contain a salutation and the service rota. Please add your own message','church-admin').'</p>';
		wp_editor('','message',"", true);
		echo'<p><input type="hidden" name="rota_email" value="yes"/><input type="submit" class="button-primary" value="'.__('Send to rota participants','church-admin').'"/></p>';
		echo'</form>';
	}
		
}







/**
* This function adds 3months worth of service to rota
*
* @author     	andymoyle
* @param		$service_id
* @return		
*
*/
function church_admin_rota_add_three_months($service_id)
{
	global $wpdb;
	$days=array(1=>'Sunday',2=>'Monday',3=>'Tuesday',4=>'Wednesday',5=>'Thursday',6=>'Friday',7=>'Saturday');
	$service=$wpdb->get_row('SELECT * FROM '.CA_SER_TBL.' WHERE service_id="'.esc_sql($service_id).'"');
	//get rota tasks for service_id
	$task_result=$wpdb->get_results('SELECT * FROM '.CA_RST_TBL.' ORDER BY rota_order');
	$jobs=array();
	foreach($task_result AS $task)
	{
		$services=maybe_unserialize($task->service_id);
		if(in_array($service_id,$services))$jobs[$task->rota_id]=serialize(array(0=>''));
	}
	$values=array();
	//handed 0.924 to look for last date of service_id not last date
	$last_date=$wpdb->get_var('SELECT rota_date FROM '.CA_ROT_TBL.' WHERE service_id="'.esc_sql($service_id).'" ORDER BY rota_date DESC LIMIT 1');
	//changed 0.924 to start from next service intended day of week not sunday!
	if(empty($last_date)) $last_date=date('Y-m-d',strtotime($days[$service->service_day]));
	for($x=1;$x<=12;$x++)
	{
		
		$values[]='("'.esc_sql(serialize($jobs)).'",DATE_ADD("'.esc_sql($last_date).'", INTERVAL '.$x.' WEEK),"'.esc_sql($service_id).'")';
	}
	$sql='INSERT INTO '.CA_ROT_TBL.' (rota_jobs,rota_date,service_id) VALUES '.implode(",",$values);
	$wpdb->query($sql);
	
	
}

function church_admin_edit_rota($id=NULL,$service_id=NULL)
{
    global $wpdb,$church_admin_version;
	$days=array(1=>__('Sunday','church-admin'),2=>__('Monday','church-admin'),3=>__('Tuesday','church-admin'),4=>__('Wednesday','church-admin'),5=>__('Thursday','church-admin'),6=>__('Friday','church-admin'),7=>__('Saturday','church-admin'));
   
     $rota_order=ca_rota_order();
    //Need to specify a service if not already
	if(empty($service_id))
    {
		$services=$wpdb->get_results('SELECT * FROM '.CA_SER_TBL);
		if($wpdb->num_rows==1)
		{
		
			$service_id=$services[0]->service_id;
		}
		else
		{
			echo'<form action="" method="POST"><p><label>'.__('Which Service?','church-admin').'</label><select name="service_id">';
			foreach($services AS $service)
			{
				echo'<option value="'.intval($service->service_id).'">'.esc_html(sprintf( __('%1$s on %2$s at %3$s', 'church-admin'),$service->service_name,$days[$service->service_day],$service->service_time)).'</option>';
			}
			echo'</select></p>';
			echo'<p class="submit"><input type="submit" name="choose_service" value="'.__('Choose service','church-admin').' &raquo;" /></p></form></div>';
		}
    }
    if($service_id)
    {//service chosen
		$task_result=$wpdb->get_results('SELECT * FROM '.CA_RST_TBL.' ORDER BY rota_order');
		if(!empty($_POST['edit_rota']))
		{
			if(!empty($_POST['rota_date'])&& church_admin_checkdate($_POST['rota_date']))
			{
				$date=$_POST['rota_date'];
			}
			$jobs=array();
			foreach($task_result AS $task)
			{
				$services=maybe_unserialize($task->service_id);
				if(in_array($service_id,$services))$jobs[$task->rota_id]=church_admin_get_people_id(stripslashes($_POST[urlencode($task->rota_id)]));
			}
			if(!$id)
			{
				$sql='SELECT rota_id FROM '.$wpdb->prefix.'church_admin_rotas WHERE rota_date="'.esc_sql($date).'"AND service_id="'.esc_sql($service_id).'"';
				$id=$wpdb->get_var($sql);
			}
			if(!empty($id))
			{//update
				$sql='UPDATE '.$wpdb->prefix.'church_admin_rotas SET rota_jobs="'.esc_sql(serialize($jobs)).'" WHERE rota_id="'.esc_sql($id).'" AND service_id="'.esc_sql($service_id).'"';
			}//end rota update
			else
			{//insert
				$sql='INSERT INTO '.$wpdb->prefix.'church_admin_rotas (rota_jobs,rota_date,service_id)VALUES("'.esc_sql(serialize($jobs)).'","'.esc_sql($date).'","'.esc_sql($service_id).'")';
			}//end insert
			$wpdb->query($sql);
			echo'<div class="updated fade"><p><strong>'.__('Rota updated','church-admin').' </strong></p></div>';
			church_admin_rota_main($service_id);
		}
		else
		{//form
			$jobs=$wpdb->get_row('SELECT * FROM '.CA_ROT_TBL.' WHERE rota_id="'.esc_sql($id).'"');
			echo'<form id="churchAdminForm" name="churchAdminForm" action="" method="post">';
			echo'<input type="hidden" name="service_id" value="'.intval($service_id).'"/>';
	    
			if(empty($jobs->rota_date))
			{
				$next_date=$wpdb->get_var('SELECT DATE_ADD(MAX(rota_date), INTERVAL 7 DAY) FROM '.$wpdb->prefix.'church_admin_rotas LIMIT 1');
				if(empty($next_date))$next_date=date("Y-m-d",strtotime("next Sunday"));
				$service=$wpdb->get_row('SELECT * FROM '.CA_SER_TBL.' WHERE service_id="'.esc_sql($service_id).'"');
				echo'<h2>Add to rota  for  '.esc_html($service->service_name.' on '.$days[$service->service_day].' at '.$service->service_time.' '.$service->venue).'</h2>';
				echo'<script type="text/javascript">jQuery(document).ready(function(){jQuery(\'#rota_date\').datepicker({dateFormat : "yy-mm-dd", changeYear: true });});</script>';
				echo'<table class="form-table"><tbody><tr><th scope="row">Rota Date:</th><td><input type="text" id="rota_date" name="rota_date" ';
				if(!empty($next_date)) echo ' value="'.esc_html($next_date).'" ';
				echo'/></td></tr></tbody></table>';
			}else
			{
					$service=$wpdb->get_row('SELECT * FROM '.CA_SER_TBL.' WHERE service_id="'.esc_sql($service_id).'"');
					echo'<h2>Edit rota for '.esc_html(mysql2date('d/m/Y',$jobs->rota_date).' and '.$service->service_name.' at '.$service->service_time.' '.$service->venue).'</h2>';
			}
			//grab different jobs
			echo'<table class="form-table"><tbody>';
			foreach($task_result as $task_row)
			{
				$services=maybe_unserialize($task_row->service_id);
				if(is_array($services)&&in_array($service_id,$services))
				{
					$job=array();
					if(!empty($jobs->rota_jobs))$job=unserialize($jobs->rota_jobs);
					echo '<tr><th scope="row">'.esc_html($task_row->rota_task).':</th><td>';
					//check if autocomplete is set
					if(!empty($task_row->autocomplete))
					{
						if(!empty($job[$task_row->rota_id])){$current=$job[$task_row->rota_id];}else{$current='';}
						echo church_admin_autocomplete($task_row->rota_id,'friends'.$task_row->rota_task,'to'.$task_row->rota_task,$current,FALSE);
					}
					else
					{	
						$curr_data='';
						if(!empty($job[$task_row->rota_id]))$curr_data=maybe_unserialize($job[$task_row->rota_id]);
						$people=array();
						if(is_array($curr_data))
						{
							foreach($curr_data AS $key=>$value)
							{
								if(ctype_digit($value))
								{//id
									$people[]=church_admin_get_person($value);
								}//id
								else
								{//text
									$people[]=$value;
								}//text
							}
						}else
						{
							$people[]=$curr_data;}
							echo'<input type="text" name="'.intval($task_row->rota_id).'"';
							if(!empty($people)){echo ' value="'.esc_html(implode(", ",$people)).'"';}
							echo'/>';
						}
						echo'</td></tr>';
					}
				}
				echo'<tr><th scope="row">&nbsp;</th><td><input class="button-primary" type="submit" name="edit_rota" value="'.__('Save','church-admin').' &raquo;" /></td></tr></table></form>';
	}//end form
    
    }//service chosen
    


}




function church_admin_delete_rota($id)
{
    global $wpdb;
      $wpdb->query("DELETE FROM ".$wpdb->prefix."church_admin_rotas WHERE rota_id='".esc_sql($id)."'");
    echo'<div class="updated fade"><p>'.__('Rota Deleted','church-admin').'</p></div>';
    church_admin_rota_list();
   
}

function church_admin_rota_csv($service_id=NULL)
{
global$wpdb,$rota_order;
$csv='';
//check rota settings!
$rota_jobs=$wpdb->get_var("SELECT COUNT(rota_id) AS rota_jobs FROM ".$wpdb->prefix."church_admin_rota_settings");

$rota_list=$wpdb->get_var("SELECT COUNT(rota_id) AS rota_list FROM ".$wpdb->prefix."church_admin_rotas");

if($rota_jobs>0&&$rota_list>0)
{
    //grab rota tasks
$taskresult=$wpdb->get_results("SELECT * FROM ".$wpdb->prefix."church_admin_rota_settings  ORDER by rota_order");
if(!empty($taskresult))
{
    if(!$service_id)
    {
	$services=$wpdb->get_results('SELECT * FROM '.CA_SER_TBL);
	if($wpdb->num_rows==1)
	{
	    $service_id=1;
	}
	else
	{
	    echo'<form action="admin.php?page=church_admin/index.php&tab=calendar&amp;action=church_admin_rota_list" method="POST">';
	    echo'<p><label>'.__('Which Service?','church-admin').'</label><select name="service_id">';
	    foreach($services AS $service)
	    {
		echo'<option value="'.intval($service->service_id).'">'.esc_html($service->service_name.' on '.$days[$service->service_day].' at '.$service->service_time.' '.$service->venue).'</option>';
	    }
	    echo'</select></p>';
	    echo'<p class="submit"><input type="submit" name="choose_service" value="'.__('Choose service','church-admin').' &raquo;" /></p></form></div>';
	}
    }
    $check=$wpdb->get_row('SELECT * FROM '.CA_SER_TBL.' WHERE service_id="'.esc_sql($service_id).'"');
    if($service_id && $service_id==$check->service_id)
    {//service chosen
	//grab already set dates from db after today
	$sql='SELECT * FROM '.$wpdb->prefix.'church_admin_rotas WHERE rota_date>="'.date('Y-m-d').'" AND service_id="'.esc_sql($service_id).'" ORDER BY rota_date LIMIT 0,52 ';
   
	$results=$wpdb->get_results($sql);
	if($results)
	{
	    $cols=$allowed_jobs=array();
		//build rota tableheader
		$service=$wpdb->get_row('SELECT * FROM '.CA_SER_TBL.' WHERE service_id="'.esc_sql($service_id).'"');
	    foreach($taskresult AS $taskrow)
	    {
			$service=maybe_unserialize($taskrow->service_id);
			if(is_array($service)&&in_array($service_id,$service))
			{
				$cols[]='"'.esc_html($taskrow->rota_task).'"';
				$allowed_jobs[]=$taskrow->rota_id;
			}
			
	    }
	    $csv.='"'.__('Date','church-admin').'",'.implode(',',$cols)."\r\n";

	    //end rota table header
    	
	    //grab results for each date
	    foreach($results AS $daterows)
	    {
	       $line=array();
		//start building row
		$line[]= '"'.mysql2date('jS M Y',$daterows->rota_date).'"';
		//get rota task people for that date
		$rota_jobs =maybe_unserialize($daterows->rota_jobs);
		$rota_order=ca_rota_order();
		
		if(!empty($rota_jobs))
		{
		    foreach($rota_order AS $order=>$id)
		    {
				if(!empty($rota_jobs[$id]))
				{
					//add entry
					$line[]='"'.church_admin_get_people($rota_jobs[$id]).'"';
					}else {$line[]='""';}
				}
			}
		if(!empty($line)){$csv.=implode(',',$line)."\r\n";}else{$csv.="\r\n";}
		}
	    
	}
	$filename="Rota-for-service-".esc_html($check->service_name).".csv";
	header("Cache-Control: public");
	header("Content-Description: File Transfer");
	header("Content-Disposition: attachment; filename=$filename");
	header("Content-Type: text/csv");
	header("Content-Transfer-Encoding: binary");

	echo $csv;
	
    }
    else echo "<p>Not possible to download that rota </p>";
}//end of non empty rota tasks.			
}
  
    
}


function church_admin_sms_rota($service_id=NULL)
{
   //2016-11-08 Changed days to non translated version
   	$debug=TRUE;
    global $wpdb;
    
    $service=$wpdb->get_row('SELECT * FROM '.CA_SER_TBL.' WHERE service_id="'.esc_sql($service_id).'"');
    echo'<h2>'.__('Sending SMS rota for ','church-admin').' '.$service->service_name.'</h2>';
	$username=get_option('church_admin_sms_username');
	$password=get_option('church_admin_sms_password');
	$sender=get_option('church_admin_sms_reply');    
	$sms_type=get_option('church_admin_bulksms');
	
	if(empty($username)||empty($password)||empty($sender)||empty($sms_type))
	{
		$out='<h2>Please setup your Bulksms account settings first</h2>';
		echo $out;
		if($debug)church_admin_debug("**********\r\n rota.php line632\r\n FORM ".$out."\r\n");
	}
	else
	{
		require_once(plugin_dir_path(__FILE__).'/sms.php');
    	$days=array(1=>'Sunday',2=>'Monday',3=>'Tuesday',4=>'Wednesday',5=>'Thursday',6=>'Friday',7=>'Saturday');if($debug)church_admin_debug('SMS Rota Send: '.date('Y-m-d h:i:s'));
		
		//grab rota job names array
		$allRotaJobs=$wpdb->get_results('SELECT * FROM '.CA_RST_TBL.' ORDER by rota_order');
				//extract ids and name of rota job for current service
				$rotaJobs=array();
				if(!empty($allRotaJobs))
				{
			
					foreach($allRotaJobs AS $eachRotaJob)
					{
						$serv_ids=maybe_unserialize($eachRotaJob->service_id);
				
						if(is_array($serv_ids)&&in_array($service_id,$serv_ids)){$rotaJobs[$eachRotaJob->rota_id]=$eachRotaJob->rota_task;}
					}
				//we now have an array $rotaJobs that contains id as key and name of job as value in the correct order
				}
				
					
		
		
		if(!empty($service_id))
		{
			
			$sql='SELECT * FROM '.CA_ROT_TBL.' WHERE service_id="'.esc_sql($service_id).'" AND rota_date>=NOW() ORDER BY rota_date ASC LIMIT 1';
			
			$row=$wpdb->get_row($sql);
			if(!empty($row))
			{
				
				
					
					$message=__("Don't forget, this ",'church-admin').''.$service->service_name.', ';
					$tasks=maybe_unserialize($row->rota_jobs);
					
					foreach($tasks AS $job=>$people)
					{
						
						
						$peeps=maybe_unserialize($people);
						if($debug)church_admin_debug("**********\r\n rota.php line688\r\n  ".print_r($peeps,TRUE)."\r\n");
						if(!empty($peeps))
						{
							foreach($peeps AS $peep)
							{
								if(!ctype_digit($peep))
								{
									if($debug)church_admin_debug("**********\r\n rota.php line280\r\n Recipient not stored as people_id\r\n".$peep."\r\n");
										$peep=church_admin_get_one_id($peep);
										if($debug)church_admin_debug("**********\r\n rota.php line283\r\n Recipient converted to  people_id hopefully!\r\n".$peep."\r\n");
										if(!ctype_digit($peep)) echo '<p>'.esc_html($peep).__('is not stored in the directory','church-admin').'</p>';
								}
								if(ctype_digit($peep))
								{
									echo'<h3>'.esc_html($rotaJobs[$job]).'</h3>';
									$sql='SELECT CONCAT_WS(first_name,prefix,last_name) AS name,mobile FROM '.CA_PEO_TBL.' WHERE people_id="'.esc_sql($peep).'"';
									$person=$wpdb->get_row($sql);
									if(!empty($person->mobile))
									{
										if($debug)church_admin_debug("**********\r\n rota.php line 701\r\n  ".print_r($person,TRUE)."\r\n");
										$result=church_admin_sms($person->mobile,$message.__('you are on','church-admin').' "'.$rotaJobs[$job].'"');
										if($debug)church_admin_debug("**********\r\n rota.php line703\r\n SENT to ".$print_r($result,TRUE)." \r\n");
										if( $result['success'] ) 
										{
											$out.='<p>'.__('SMS sent to','church-admin').' '.esc_html($person->name).'</p>';
											
										}
									}
								}else $out.='<p>'.esc_html($peep)." wasn't stored in the directory</p>";
							}
					}
			}
				
		}
	}
	}
}




?>